;NSIS script for i4uc

;--------------------------------
;Include Modern UI
  !include "MUI2.nsh"
  !include "EnvVarUpdate.nsh"


;--------------------------------
;General

  Name "i4uc"
  OutFile "i4uc-0.5.6-setup.exe"
  InstallDir "c:\i4uc"
  ShowInstDetails show
  ShowUnInstDetails show
  !ifdef NSIS_LZMA_COMPRESS_WHOLE
    SetCompressor lzma
  !else
    SetCompressor /SOLID lzma
  !endif
  

;--------------------------------
;Interface Configuration

  !define MUI_HEADERIMAGE
  !define MUI_HEADERIMAGE_BITMAP "../pixmaps/i4uc_header.bmp"
  !define MUI_ABORTWARNING


;--------------------------------
;Pages
  
  !insertmacro MUI_PAGE_WELCOME
  !insertmacro MUI_PAGE_LICENSE "${PKG_DIR}\doc\i4uc\COPYING"
  !insertmacro MUI_PAGE_COMPONENTS
  
  Var StartMenuFolder
  !insertmacro MUI_PAGE_STARTMENU Application $StartMenuFolder
  
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
  ;Finish page
  !define MUI_FINISHPAGE_LINK "http://trac.usla.org.ar/i4uc/"
  !define MUI_FINISHPAGE_LINK_LOCATION "http://trac.usla.org.ar/i4uc/"
  !insertmacro MUI_PAGE_FINISH


;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"
  !insertmacro MUI_LANGUAGE "Spanish"


;--------------------------------
;Installer Sections

Section "I4uc" I4uc

  ;Executables and libraries
  SetOutPath "$INSTDIR\bin"
  File "${PKG_DIR}\bin\i4uc-gtk.exe"
  File "${MINGW_DIR}\bin\gspawn-win32-helper.exe"
  File "${MINGW_DIR}\bin\libatk-1.0-0.dll"
  File "${MINGW_DIR}\bin\libcairo-2.dll"
  File "${MINGW_DIR}\bin\libexpat-1.dll"
  File "${MINGW_DIR}\bin\libfontconfig-1.dll"
  File "${MINGW_DIR}\bin\libfreetype-6.dll"
  File "${MINGW_DIR}\bin\libgdk_pixbuf-2.0-0.dll"
  File "${MINGW_DIR}\bin\libgdk-win32-2.0-0.dll"
  File "${MINGW_DIR}\bin\libgee-2.dll"
  File "${MINGW_DIR}\bin\libgio-2.0-0.dll"
  File "${MINGW_DIR}\bin\libglib-2.0-0.dll"
  File "${MINGW_DIR}\bin\libgmodule-2.0-0.dll"
  File "${MINGW_DIR}\bin\libgobject-2.0-0.dll"
  File "${MINGW_DIR}\bin\libgthread-2.0-0.dll"
  File "${MINGW_DIR}\bin\libgtksourceview-2.0-0.dll"
  File "${MINGW_DIR}\bin\libgtk-win32-2.0-0.dll"
  File "${MINGW_DIR}\bin\libiconv-2.dll"
  File "${MINGW_DIR}\bin\libintl-8.dll"
  File "${MINGW_DIR}\bin\libjpeg-8.dll"
  File "${MINGW_DIR}\bin\libpango-1.0-0.dll"
  File "${MINGW_DIR}\bin\libpangocairo-1.0-0.dll"
  File "${MINGW_DIR}\bin\libpangoft2-1.0-0.dll"
  File "${MINGW_DIR}\bin\libpangowin32-1.0-0.dll"
  File "${MINGW_DIR}\bin\libpixman-1-0.dll"
  File "${MINGW_DIR}\bin\libpng14.dll"
  File "${MINGW_DIR}\bin\libxml2-2.dll"
  File "${MINGW_DIR}\bin\zlib1.dll"
  
  ;GtkSourceView language-specs and styles, locales and clearlooks engine
  SetOutPath "$INSTDIR\share\gtksourceview-2.0\language-specs"
  File "${MINGW_DIR}\share\gtksourceview-2.0\language-specs\*.*"
  File "${PKG_DIR}\share\gtksourceview-2.0\language-specs\*.*"
  SetOutPath "$INSTDIR\share\gtksourceview-2.0\styles"
  File "${MINGW_DIR}\share\gtksourceview-2.0\styles\*.*"
  SetOutPath "$INSTDIR\share\locale\es\LC_MESSAGES"
  File "${MINGW_DIR}\share\locale\es\LC_MESSAGES\*.*"
  File "${PKG_DIR}\share\locale\es\LC_MESSAGES\*.*"
  SetOutPath "$INSTDIR\etc\gtk-2.0"
  File "${MINGW_DIR}\share\themes\Clearlooks\gtk-2.0\gtkrc"
  SetOutPath "$INSTDIR\lib\gtk-2.0\2.10.0\engines"
  File "${MINGW_DIR}\lib\gtk-2.0\2.10.0\engines\libclearlooks.dll"
  
  ;i4uc docs and pixmaps
  SetOutPath "$INSTDIR\doc\i4uc"
  File "${PKG_DIR}\doc\i4uc\*.*"
  SetOutPath "$INSTDIR\share\i4uc\pixmaps"
  File "${PKG_DIR}\share\i4uc\pixmaps\erase-flash.png"
  File "${PKG_DIR}\share\i4uc\pixmaps\icon.ico"
  File "${PKG_DIR}\share\i4uc\pixmaps\icon.png"
  File "${PKG_DIR}\share\i4uc\pixmaps\programmer-icon.png"
  File "${PKG_DIR}\share\i4uc\pixmaps\read-flash.png"
  File "${PKG_DIR}\share\i4uc\pixmaps\splashscreen.png"
  File "${PKG_DIR}\share\i4uc\pixmaps\verify-flash.png"
  File "${PKG_DIR}\share\i4uc\pixmaps\write-flash.png"
  
  ;Programmers
  SetOutPath "$INSTDIR\share\i4uc\programmers"
  File "${PKG_DIR}\share\i4uc\programmers\avrdude.xml"
  File "${PKG_DIR}\share\i4uc\programmers\lpc21isp.xml"
  File "${PKG_DIR}\share\i4uc\programmers\pickit2.xml"
  File "${PKG_DIR}\share\i4uc\programmers\picprog.xml"
  File "${PKG_DIR}\share\i4uc\programmers\picstartplus.xml"
  
  ;Builders
  SetOutPath "$INSTDIR\share\i4uc\builders"
  File "${PKG_DIR}\share\i4uc\builders\arm-elf-gcc.xml"
  File "${PKG_DIR}\share\i4uc\builders\arm-none-eabi-gcc.xml"
  File "${PKG_DIR}\share\i4uc\builders\avr-gcc.xml"
  File "${PKG_DIR}\share\i4uc\builders\msp430-gcc.xml"
  File "${PKG_DIR}\share\i4uc\builders\pic14-sdcc.xml"
  File "${PKG_DIR}\share\i4uc\builders\pic16-sdcc.xml"

  ;PATH
  ${EnvVarUpdate} $0 "PATH" "A" "HKLM" "$INSTDIR\bin"
SectionEnd


;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_i4uc ${LANG_ENGLISH} "IDE for microcontrollers."
  LangString DESC_i4uc ${LANG_SPANISH} "IDE para microcontroladores."
  
  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${i4uc} $(DESC_i4uc)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END


;--------------------------------
;Shortcuts

Section -Icons

!insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  SetOutPath "$INSTDIR\bin"
  CreateDirectory "$SMPROGRAMS\$StartMenuFolder"
  CreateShortCut "$SMPROGRAMS\$StartMenuFolder\i4uc.lnk" "$INSTDIR\bin\i4uc-gtk.exe" "" "$INSTDIR\share\i4uc\pixmaps\icon.ico"
  CreateShortCut "$SMPROGRAMS\$StartMenuFolder\uninstall.lnk" "$INSTDIR\uninstall.exe"
  CreateDirectory "$DESKTOP"
  CreateShortCut "$DESKTOP\i4uc.lnk" "$INSTDIR\bin\i4uc-gtk.exe" "" "$INSTDIR\share\i4uc\pixmaps\icon.ico" "" "" "" ""
!insertmacro MUI_STARTMENU_WRITE_END

SectionEnd

;--------------------------------
;Post install

Section -PostInstall

  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\i4uc" "DisplayName" "i4uc"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\i4uc" "UninstallString" "$INSTDIR\uninstall.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\i4uc" "Publisher" "Matias De la Puente"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\i4uc" "URLInfoAbout" "http://trac.usla.org.ar/i4uc/"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\i4uc" "HelpLink" "http://trac.usla.org.ar/i4uc/"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\i4uc" "URLUpdateInfo" "http://trac.usla.org.ar/i4uc/"
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\uninstall.exe"

SectionEnd

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ${un.EnvVarUpdate} $0 "PATH" "R" "HKLM" "$INSTDIR\bin"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\i4uc"
  Delete "$DESKTOP\i4uc.lnk"
  Delete "$SMPROGRAMS\$StartMenuFolder\*"
  RMDir /r "$INSTDIR"

SectionEnd
