/* addprofiledialogview.vala
 *
 * Copyright (C) 2010  Matias De la Puente
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Matias De la Puente <mfpuente.ar@gmail.com>
 */
using Gee;

public interface I4uc.Core.AddProfileDialogView : GLib.Object
{
	public abstract bool is_new { get; }
	public abstract bool is_public { get; }
	public abstract string warning_message { set; get; }
	public abstract string profile_name { owned get; }
	public abstract string folder_uri { set; owned get; }
	public abstract string project_uri { owned get; }

	public abstract bool warning_message_visible { set; get; }
	public abstract bool new_profile_sensitive { set; get; }
	public abstract bool import_project_sensitive { set; get; }
	public abstract bool import_profile_sensitive { set; get; }
	public abstract bool accept_sensitive { set; get; }

	public signal void is_new_changed ();
	public signal void new_profile_changed ();
	public signal void import_project_changed ();
	public signal void import_profile_changed ();

	public abstract void add_profiles (Collection<string> profiles);
	public abstract void clear_profiles_list ();
	public abstract DialogResponse run ();
	public abstract void close ();
}
