/* app.vala
 *
 * Copyright (C) 2010-2011  Matias De la Puente
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Matias De la Puente <mfpuente.ar@gmail.com>
 */

public interface I4uc.Core.App : GLib.Object
{
	public abstract ViewFactory view_factory { get; }

	public abstract DocumentsView documents_view { get; }
	public abstract MainWindowView main_window_view { get; }
	public abstract ProgrammersView programmers_view { get; }
	public abstract ProjectsView projects_view { get; }
	
	public abstract DocumentsLogic documents_logic { get; }
	public abstract MainWindowLogic main_window_logic { get; }
	public abstract ProgrammersLogic programmers_logic { get; }
	public abstract ProjectsLogic projects_logic { get; }

	public abstract Settings settings { get; }
	
	public abstract Gee.Map<string, Builder> builders { get; }
	public abstract Gee.Map<string, Programmer> programmers { get; }
	
	public abstract void add_recent (string uri);
}
