/* builderslist.vala
 *
 * Copyright (C) 2010-2011  Matias De la Puente
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Matias De la Puente <mfpuente.ar@gmail.com>
 */

public interface I4uc.Core.BuildersList : GLib.Object
{
	public abstract string current_builder { set; get; }
	public abstract string current_output_type { set; get; }
	public abstract string current_device { set; get; }
	public abstract OptionsView compile_options_view { get; }
	public abstract OptionsView link_options_view { get; }
	
	public abstract bool compile_options_visible { set; get; }
	
	public abstract void add_builder (string builder);
	public abstract void add_output_type (string output_type);
	public abstract void add_device (string device);
	public abstract void clear_builders_list ();
	public abstract void clear_output_types_list ();
	public abstract void clear_devices_list ();
}
