/* documentsview.vala
 *
 * Copyright (C) 2010-2011  Matias De la Puente
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Matias De la Puente <mfpuente.ar@gmail.com>
 */
using Gee;

public interface I4uc.Core.DocumentsView : GLib.Object
{
	public abstract bool save_sensitive { set; get; }
	public abstract bool save_as_sensitive { set; get; }
	public abstract bool print_sensitive { set; get; }
	public abstract bool undo_sensitive { set; get; }
	public abstract bool redo_sensitive { set; get; }
	public abstract bool cut_sensitive { set; get; }
	public abstract bool copy_sensitive { set; get; }
	public abstract bool paste_sensitive { set; get; }
	public abstract bool search_sensitive { set; get; }
	public abstract bool save_all_sensitive { set; get; }
	public abstract bool close_all_sensitive { set; get; }
	public abstract bool previous_sensitive { set; get; }
	public abstract bool next_sensitive { set; get; }
	
	public abstract PagesPanel pages_panel { get; }
	public abstract SyntaxHighlightMenu syntax_highlight_menu { get; }
	public abstract bool syntax_highlight_menu_sensitive { set; get; }
	public abstract DocumentPreferencesPageView preferences_page_view { get; }
	
	public signal void new_clicked ();
	public signal void open_clicked ();
	public signal void open_recent_clicked (string uri);
	public signal void save_clicked ();
	public signal void save_as_clicked ();
	public signal void print_clicked ();
	public signal void page_setup_clicked ();
	public signal void undo_clicked ();
	public signal void redo_clicked ();
	public signal void cut_clicked ();
	public signal void copy_clicked ();
	public signal void paste_clicked ();
	public signal void search_clicked ();
	public signal void save_all_clicked ();
	public signal void close_all_clicked ();
	public signal void previous_clicked ();
	public signal void next_clicked ();
	
	public abstract DocumentPageView create_page_view ();
	public abstract void show_page_setup_dialog ();
	public abstract DialogResponse show_close_confirmation_dialog (Gee.Map<string, string> unsaved_documents, out Gee.List<string> documents_to_save);
}
