/* pagespanel.vala
 *
 * Copyright (C) 2010-2011  Matias De la Puente
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Matias De la Puente <mfpuente.ar@gmail.com>
 */
using Gee;

public enum I4uc.Core.PagePosition
{
	BOTTOM,
	LEFT,
	RIGHT,
	TOP
}

public interface I4uc.Core.PagesPanel : GLib.Object
{
	public abstract Page current_page { get; }
	public abstract PagePosition page_position { set; get; }

	public signal void page_added (Page page);
	public signal void page_removed (Page page);
	public signal void page_changed (Page? page);
	
	public abstract int get_page_num (Page page);
	public abstract int get_num_of_pages ();
	public abstract void add_page (Page page);
	public abstract void insert_page (Page page, int position);
	public abstract void remove_page (Page page);
	public abstract void show_page (Page page);
	public abstract Gee.List<Page> list_pages ();
	public abstract void previous_page ();
	public abstract void next_page ();
}
