/* posixcommandrunner.vala
 *
 * Copyright (C) 2010-2011  Matias De la Puente
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Matias De la Puente <mfpuente.ar@gmail.com>
 */
using Posix;

public class I4uc.Core.PosixCommandRunner : CommandRunner
{
	protected override void close_process ()
	{
		Posix.kill ((Posix.pid_t)_child_pid, Posix.SIGKILL);
	}
	
	protected override IOChannel create_io_channel (int fd)
	{
		var io_channel = new IOChannel.unix_new (fd);
		io_channel.set_flags (io_channel.get_flags () | IOFlags.NONBLOCK);
		return io_channel;
	}
}
