/* profiledialogview.vala
 *
 * Copyright (C) 2010  Matias De la Puente
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Matias De la Puente <mfpuente.ar@gmail.com>
 */
using Gee;

public interface I4uc.Core.ProfileDialogView : GLib.Object
{
	public abstract string title { set; get; }
	public abstract string profile_name { set; owned get; }
	public abstract bool is_public { set; get; }
	public abstract Gee.List<string> activated_files { owned get; }
	public abstract string warning_message { set; get; }
	
	public abstract bool warning_message_visible { set; get; }
	public abstract bool accept_sensitive { set; get; }
	
	public abstract void add_file (string file, bool active);
	public abstract DialogResponse run ();
	public abstract void close ();
}
