/* projectspageview.vala
 *
 * Copyright (C) 2010  Matias De la Puente
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Matias De la Puente <mfpuente.ar@gmail.com>
 */

public interface I4uc.Core.ProjectsPageView : GLib.Object, Page
{
	public abstract string current_project { set; get; }
	public abstract string current_project_tooltip { set; get; }
	public abstract string current_profile { set; get; }
	public abstract string current_file { get; }
	public abstract bool profiles_check_list_sensitive { set; get; }
	public abstract bool profiles_check_list_visible { set; get; }
	public abstract BuildersList builders_list { get;  }
	public abstract bool builders_list_sensitive { set; get; }
	public abstract bool builders_list_visible { set; get; }
	public abstract bool profile_edit_sensitive { set; get; }

	public signal void profile_edit_clicked ();
	public signal void profile_check_changed (string profile, bool active);
	public signal void file_changed ();
	public signal void file_activated ();

	public abstract void add_project (string project_uri, string project_name);
	public abstract void add_profile (string profile_id, string? profile_label=null, bool on_check_list=true);
	public abstract void change_profile (string profile_id, string new_profile_id, string? new_profile_label=null);
	public abstract void add_file (string file);
	public abstract void check_profile (string profile, bool active);
	public abstract void uncheck_all_profiles ();
	public abstract void remove_project (string project_uri);
	public abstract void remove_profile (string profile);
	public abstract void remove_file (string file);
	public abstract void clear_profiles_list ();
	public abstract void clear_files_list ();
	public abstract ProfileDialogView create_profile_dialog_view ();
}
