/* serialportutils.vala
 *
 * Copyright (C) 2010  Matias De la Puente
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Matias De la Puente <mfpuente.ar@gmail.com>
 */
using Gee;

public abstract class I4uc.Core.SerialPortUtils : GLib.Object
{
	public abstract Gee.List<string> list_serial_ports ();
	
	public Gee.List<string> list_baud_rates ()
	{
		var baud_rates = new ArrayList<string> ();
		
		baud_rates.add ("300");
		baud_rates.add ("600");
		baud_rates.add ("1200");
		baud_rates.add ("2400");
		baud_rates.add ("4800");
		baud_rates.add ("9600");
		baud_rates.add ("19200");
		baud_rates.add ("38400");
		baud_rates.add ("57600");
		baud_rates.add ("115200");
		
		return baud_rates.read_only_view;
	}
}

namespace I4uc.Core
{
	//Defined in serialportutilsfactory.c
	public extern SerialPortUtils create_serial_port_utils ();
}
